<?xml version="1.0" encoding="US-ASCII"?>
<!-- DFIN New ActiveDisclosure (SM) XBRL Schema Document - http://www.dfinsolutions.com/ -->
<!-- Creation Date :2023-04-11T09:41:28.9749+00:00 -->
<!-- Copyright (c) 2023 Donnelly Financial Solutions, Inc. All Rights Reserved. -->
<xsd:schema targetNamespace="http://www.spartannash.com/20230411" attributeFormDefault="unqualified" elementFormDefault="qualified" xmlns:dtr-types="http://www.xbrl.org/dtr/type/2020-01-21" xmlns:enum2="http://xbrl.org/2020/extensible-enumerations-2.0" xmlns:sptn="http://www.spartannash.com/20230411" xmlns:ecd-sub="http://xbrl.sec.gov/ecd-sub/2022q4" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:link="http://www.xbrl.org/2003/linkbase" xmlns:us-gaap="http://fasb.org/us-gaap/2022" xmlns:dei="http://xbrl.sec.gov/dei/2022" xmlns:xbrldt="http://xbrl.org/2005/xbrldt" xmlns:xbrli="http://www.xbrl.org/2003/instance" xmlns:xlink="http://www.w3.org/1999/xlink">
  <xsd:import schemaLocation="http://www.xbrl.org/2003/xbrl-instance-2003-12-31.xsd" namespace="http://www.xbrl.org/2003/instance"/>
  <xsd:import schemaLocation="http://www.xbrl.org/2003/xbrl-linkbase-2003-12-31.xsd" namespace="http://www.xbrl.org/2003/linkbase"/>
  <xsd:import schemaLocation="http://www.xbrl.org/2005/xbrldt-2005.xsd" namespace="http://xbrl.org/2005/xbrldt"/>
  <xsd:import schemaLocation="https://xbrl.sec.gov/dei/2022/dei-2022.xsd" namespace="http://xbrl.sec.gov/dei/2022"/>
  <xsd:import schemaLocation="https://xbrl.fasb.org/us-gaap/2022/elts/us-gaap-2022.xsd" namespace="http://fasb.org/us-gaap/2022"/>
  <xsd:import schemaLocation="https://www.xbrl.org/dtr/type/2020-01-21/types.xsd" namespace="http://www.xbrl.org/dtr/type/2020-01-21"/>
  <xsd:import schemaLocation="https://xbrl.sec.gov/ecd/2022q4/ecd-sub-2022q4.xsd" namespace="http://xbrl.sec.gov/ecd-sub/2022q4"/>
  <xsd:annotation>
    <xsd:appinfo>
      <link:linkbaseRef xlink:arcrole="http://www.w3.org/1999/xlink/properties/linkbase" xlink:href="sptn-20230411_lab.xml" xlink:role="http://www.xbrl.org/2003/role/labelLinkbaseRef" xlink:title="Labels link" xlink:type="simple"/>
      <link:linkbaseRef xlink:arcrole="http://www.w3.org/1999/xlink/properties/linkbase" xlink:href="sptn-20230411_pre.xml" xlink:role="http://www.xbrl.org/2003/role/presentationLinkbaseRef" xlink:title="Presentation link" xlink:type="simple"/>
      <link:linkbaseRef xlink:arcrole="http://www.w3.org/1999/xlink/properties/linkbase" xlink:href="sptn-20230411_def.xml" xlink:role="http://www.xbrl.org/2003/role/definitionLinkbaseRef" xlink:title="Definition link" xlink:type="simple"/>
      <link:roleType roleURI="http://www.spartannash.com/20230411/taxonomy/role/DocumentDocumentAndEntityInformation" id="DocumentDocumentAndEntityInformation">
        <link:definition>100000 - Document - Document and Entity Information</link:definition>
        <link:usedOn>link:presentationLink</link:usedOn>
        <link:usedOn>link:calculationLink</link:usedOn>
        <link:usedOn>link:definitionLink</link:usedOn>
      </link:roleType>
    </xsd:appinfo>
  </xsd:annotation>
  <xsd:element id="sptn_InitialFixedInvestmentValue" name="InitialFixedInvestmentValue" type="xbrli:monetaryItemType" substitutionGroup="xbrli:item" xbrli:periodType="instant" nillable="true" abstract="false" xbrli:balance="debit"/>
  <xsd:element id="sptn_ChangeInFairValueAsOfVestingDateOfStockAwardsGrantedInPriorYearsForWhichApplicableVestingConditionsWereSatisfiedDuringFiscalYearMember" name="ChangeInFairValueAsOfVestingDateOfStockAwardsGrantedInPriorYearsForWhichApplicableVestingConditionsWereSatisfiedDuringFiscalYearMember" type="dtr-types:domainItemType" substitutionGroup="xbrli:item" xbrli:periodType="duration" nillable="true" abstract="true"/>
  <xsd:element id="sptn_ChangeInFairValueOfDividendsMember" name="ChangeInFairValueOfDividendsMember" type="dtr-types:domainItemType" substitutionGroup="xbrli:item" xbrli:periodType="duration" nillable="true" abstract="true"/>
  <xsd:element id="sptn_ChangeInFairValueOfOutstandingAndUnvestedStockAwardsGrantedInPriorFiscalYearMember" name="ChangeInFairValueOfOutstandingAndUnvestedStockAwardsGrantedInPriorFiscalYearMember" type="dtr-types:domainItemType" substitutionGroup="xbrli:item" xbrli:periodType="duration" nillable="true" abstract="true"/>
  <xsd:element id="sptn_DennisEidsonMember" name="DennisEidsonMember" type="dtr-types:domainItemType" substitutionGroup="xbrli:item" xbrli:periodType="duration" nillable="true" abstract="true"/>
  <xsd:element id="sptn_FairValueAsOfPriorFiscalYearEndOfStockAwardsGrantedInPriorFiscalYearsThatFailedToMeetApplicableVestingConditionsDuringFiscalYearMember" name="FairValueAsOfPriorFiscalYearEndOfStockAwardsGrantedInPriorFiscalYearsThatFailedToMeetApplicableVestingConditionsDuringFiscalYearMember" type="dtr-types:domainItemType" substitutionGroup="xbrli:item" xbrli:periodType="duration" nillable="true" abstract="true"/>
  <xsd:element id="sptn_FairValueAtFiscalYearEndOfOutstandingAndUnvestedStockAwardsGrantedInFiscalYearMember" name="FairValueAtFiscalYearEndOfOutstandingAndUnvestedStockAwardsGrantedInFiscalYearMember" type="dtr-types:domainItemType" substitutionGroup="xbrli:item" xbrli:periodType="duration" nillable="true" abstract="true"/>
  <xsd:element id="sptn_FairValueAtVestingOfStockAwardsGrantedInFiscalYearThatVestedDuringFiscalYearMember" name="FairValueAtVestingOfStockAwardsGrantedInFiscalYearThatVestedDuringFiscalYearMember" type="dtr-types:domainItemType" substitutionGroup="xbrli:item" xbrli:periodType="duration" nillable="true" abstract="true"/>
  <xsd:element id="sptn_GrantDateFairValueOfStockAwardsGrantedInFiscalYearMember" name="GrantDateFairValueOfStockAwardsGrantedInFiscalYearMember" type="dtr-types:domainItemType" substitutionGroup="xbrli:item" xbrli:periodType="duration" nillable="true" abstract="true"/>
  <xsd:element id="sptn_TonySarsamMember" name="TonySarsamMember" type="dtr-types:domainItemType" substitutionGroup="xbrli:item" xbrli:periodType="duration" nillable="true" abstract="true"/>
</xsd:schema>